/**
 * POCDMT000040Material.java
 *
 * File generated from the cdaepsos::POCDMT000040Material uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.cdaepsos;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class POCDMT000040Material.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "POCD_MT000040.Material", propOrder = {
	"realmCode",
	"typeId",
	"templateId",
	"id",
	"code",
	"name",
	"desc",
	"riskCode",
	"handlingCode",
	"formCode",
	"lotNumberText",
	"expirationTime",
	"stabilityTime",
	"asDistributedProduct",
	"asMedicineManufacturer",
	"asContent",
	"asSpecializedKind",
	"part",
	"ingredient",
	"classCode",
	"determinerCode",
	"nullFlavor"
})
@XmlRootElement(name = "POCD_MT000040.Material")
public class POCDMT000040Material implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "realmCode", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.CS> realmCode;
	@XmlElement(name = "typeId", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId typeId;
	@XmlElement(name = "templateId", namespace = "urn:hl7-org:v3")
	public List<net.ihe.gazelle.datatypes.II> templateId;
	@XmlElement(name = "id", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.II id;
	@XmlElement(name = "code", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.CE code;
	@XmlElement(name = "name", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.EN name;
	@XmlElement(name = "desc", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.ED desc;
	@XmlElement(name = "riskCode", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.CE riskCode;
	@XmlElement(name = "handlingCode", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.CE handlingCode;
	@XmlElement(name = "formCode", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.CE formCode;
	@XmlElement(name = "lotNumberText", namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.datatypes.ST lotNumberText;
	@XmlElement(name = "expirationTime", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.IVLTS expirationTime;
	@XmlElement(name = "stabilityTime", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.IVLTS stabilityTime;
	@XmlElement(name = "asDistributedProduct", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct> asDistributedProduct;
	@XmlElement(name = "asMedicineManufacturer", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer> asMedicineManufacturer;
	@XmlElement(name = "asContent", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.COCTMT230100UVContent asContent;
	@XmlElement(name = "asSpecializedKind", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind> asSpecializedKind;
	@XmlElement(name = "part", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVPart> part;
	@XmlElement(name = "ingredient", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.COCTMT230100UVIngredient> ingredient;
	@XmlAttribute(name = "classCode")
	public net.ihe.gazelle.voc.EntityClassManufacturedMaterial classCode;
	@XmlAttribute(name = "determinerCode")
	public net.ihe.gazelle.voc.EntityDeterminerDetermined determinerCode;
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.voc.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return realmCode.
	 * @return realmCode
	 */
	public List<net.ihe.gazelle.datatypes.CS> getRealmCode() {
		if (realmCode == null) {
	        realmCode = new ArrayList<net.ihe.gazelle.datatypes.CS>();
	    }
	    return realmCode;
	}
	
	/**
	 * Set a value to attribute realmCode.
	 * @param realmCode.
	 */
	public void setRealmCode(List<net.ihe.gazelle.datatypes.CS> realmCode) {
	    this.realmCode = realmCode;
	}
	
	
	
	/**
	 * Add a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to add.
	 */
	public void addRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.add(realmCode_elt);
	}
	
	/**
	 * Remove a realmCode to the realmCode collection.
	 * @param realmCode_elt Element to remove
	 */
	public void removeRealmCode(net.ihe.gazelle.datatypes.CS realmCode_elt) {
	    this.realmCode.remove(realmCode_elt);
	}
	
	/**
	 * Return typeId.
	 * @return typeId
	 */
	public net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId getTypeId() {
	    return typeId;
	}
	
	/**
	 * Set a value to attribute typeId.
	 * @param typeId.
	 */
	public void setTypeId(net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId typeId) {
	    this.typeId = typeId;
	}
	
	
	
	
	/**
	 * Return templateId.
	 * @return templateId
	 */
	public List<net.ihe.gazelle.datatypes.II> getTemplateId() {
		if (templateId == null) {
	        templateId = new ArrayList<net.ihe.gazelle.datatypes.II>();
	    }
	    return templateId;
	}
	
	/**
	 * Set a value to attribute templateId.
	 * @param templateId.
	 */
	public void setTemplateId(List<net.ihe.gazelle.datatypes.II> templateId) {
	    this.templateId = templateId;
	}
	
	
	
	/**
	 * Add a templateId to the templateId collection.
	 * @param templateId_elt Element to add.
	 */
	public void addTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.templateId.add(templateId_elt);
	}
	
	/**
	 * Remove a templateId to the templateId collection.
	 * @param templateId_elt Element to remove
	 */
	public void removeTemplateId(net.ihe.gazelle.datatypes.II templateId_elt) {
	    this.templateId.remove(templateId_elt);
	}
	
	/**
	 * Return id.
	 * @return id
	 */
	public net.ihe.gazelle.medication.II getId() {
	    return id;
	}
	
	/**
	 * Set a value to attribute id.
	 * @param id.
	 */
	public void setId(net.ihe.gazelle.medication.II id) {
	    this.id = id;
	}
	
	
	
	
	/**
	 * Return code.
	 * @return code
	 */
	public net.ihe.gazelle.datatypes.CE getCode() {
	    return code;
	}
	
	/**
	 * Set a value to attribute code.
	 * @param code.
	 */
	public void setCode(net.ihe.gazelle.datatypes.CE code) {
	    this.code = code;
	}
	
	
	
	
	/**
	 * Return name.
	 * @return name
	 */
	public net.ihe.gazelle.datatypes.EN getName() {
	    return name;
	}
	
	/**
	 * Set a value to attribute name.
	 * @param name.
	 */
	public void setName(net.ihe.gazelle.datatypes.EN name) {
	    this.name = name;
	}
	
	
	
	
	/**
	 * Return desc.
	 * @return desc
	 */
	public net.ihe.gazelle.medication.ED getDesc() {
	    return desc;
	}
	
	/**
	 * Set a value to attribute desc.
	 * @param desc.
	 */
	public void setDesc(net.ihe.gazelle.medication.ED desc) {
	    this.desc = desc;
	}
	
	
	
	
	/**
	 * Return riskCode.
	 * @return riskCode
	 */
	public net.ihe.gazelle.medication.CE getRiskCode() {
	    return riskCode;
	}
	
	/**
	 * Set a value to attribute riskCode.
	 * @param riskCode.
	 */
	public void setRiskCode(net.ihe.gazelle.medication.CE riskCode) {
	    this.riskCode = riskCode;
	}
	
	
	
	
	/**
	 * Return handlingCode.
	 * @return handlingCode
	 */
	public net.ihe.gazelle.medication.CE getHandlingCode() {
	    return handlingCode;
	}
	
	/**
	 * Set a value to attribute handlingCode.
	 * @param handlingCode.
	 */
	public void setHandlingCode(net.ihe.gazelle.medication.CE handlingCode) {
	    this.handlingCode = handlingCode;
	}
	
	
	
	
	/**
	 * Return formCode.
	 * @return formCode
	 */
	public net.ihe.gazelle.medication.CE getFormCode() {
	    return formCode;
	}
	
	/**
	 * Set a value to attribute formCode.
	 * @param formCode.
	 */
	public void setFormCode(net.ihe.gazelle.medication.CE formCode) {
	    this.formCode = formCode;
	}
	
	
	
	
	/**
	 * Return lotNumberText.
	 * @return lotNumberText
	 */
	public net.ihe.gazelle.datatypes.ST getLotNumberText() {
	    return lotNumberText;
	}
	
	/**
	 * Set a value to attribute lotNumberText.
	 * @param lotNumberText.
	 */
	public void setLotNumberText(net.ihe.gazelle.datatypes.ST lotNumberText) {
	    this.lotNumberText = lotNumberText;
	}
	
	
	
	
	/**
	 * Return expirationTime.
	 * @return expirationTime
	 */
	public net.ihe.gazelle.medication.IVLTS getExpirationTime() {
	    return expirationTime;
	}
	
	/**
	 * Set a value to attribute expirationTime.
	 * @param expirationTime.
	 */
	public void setExpirationTime(net.ihe.gazelle.medication.IVLTS expirationTime) {
	    this.expirationTime = expirationTime;
	}
	
	
	
	
	/**
	 * Return stabilityTime.
	 * @return stabilityTime
	 */
	public net.ihe.gazelle.medication.IVLTS getStabilityTime() {
	    return stabilityTime;
	}
	
	/**
	 * Set a value to attribute stabilityTime.
	 * @param stabilityTime.
	 */
	public void setStabilityTime(net.ihe.gazelle.medication.IVLTS stabilityTime) {
	    this.stabilityTime = stabilityTime;
	}
	
	
	
	
	/**
	 * Return asDistributedProduct.
	 * @return asDistributedProduct
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct> getAsDistributedProduct() {
		if (asDistributedProduct == null) {
	        asDistributedProduct = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct>();
	    }
	    return asDistributedProduct;
	}
	
	/**
	 * Set a value to attribute asDistributedProduct.
	 * @param asDistributedProduct.
	 */
	public void setAsDistributedProduct(List<net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct> asDistributedProduct) {
	    this.asDistributedProduct = asDistributedProduct;
	}
	
	
	
	/**
	 * Add a asDistributedProduct to the asDistributedProduct collection.
	 * @param asDistributedProduct_elt Element to add.
	 */
	public void addAsDistributedProduct(net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct asDistributedProduct_elt) {
	    this.asDistributedProduct.add(asDistributedProduct_elt);
	}
	
	/**
	 * Remove a asDistributedProduct to the asDistributedProduct collection.
	 * @param asDistributedProduct_elt Element to remove
	 */
	public void removeAsDistributedProduct(net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct asDistributedProduct_elt) {
	    this.asDistributedProduct.remove(asDistributedProduct_elt);
	}
	
	/**
	 * Return asMedicineManufacturer.
	 * @return asMedicineManufacturer
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer> getAsMedicineManufacturer() {
		if (asMedicineManufacturer == null) {
	        asMedicineManufacturer = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer>();
	    }
	    return asMedicineManufacturer;
	}
	
	/**
	 * Set a value to attribute asMedicineManufacturer.
	 * @param asMedicineManufacturer.
	 */
	public void setAsMedicineManufacturer(List<net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer> asMedicineManufacturer) {
	    this.asMedicineManufacturer = asMedicineManufacturer;
	}
	
	
	
	/**
	 * Add a asMedicineManufacturer to the asMedicineManufacturer collection.
	 * @param asMedicineManufacturer_elt Element to add.
	 */
	public void addAsMedicineManufacturer(net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer asMedicineManufacturer_elt) {
	    this.asMedicineManufacturer.add(asMedicineManufacturer_elt);
	}
	
	/**
	 * Remove a asMedicineManufacturer to the asMedicineManufacturer collection.
	 * @param asMedicineManufacturer_elt Element to remove
	 */
	public void removeAsMedicineManufacturer(net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer asMedicineManufacturer_elt) {
	    this.asMedicineManufacturer.remove(asMedicineManufacturer_elt);
	}
	
	/**
	 * Return asContent.
	 * @return asContent
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVContent getAsContent() {
	    return asContent;
	}
	
	/**
	 * Set a value to attribute asContent.
	 * @param asContent.
	 */
	public void setAsContent(net.ihe.gazelle.medication.COCTMT230100UVContent asContent) {
	    this.asContent = asContent;
	}
	
	
	
	
	/**
	 * Return asSpecializedKind.
	 * @return asSpecializedKind
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind> getAsSpecializedKind() {
		if (asSpecializedKind == null) {
	        asSpecializedKind = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind>();
	    }
	    return asSpecializedKind;
	}
	
	/**
	 * Set a value to attribute asSpecializedKind.
	 * @param asSpecializedKind.
	 */
	public void setAsSpecializedKind(List<net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind> asSpecializedKind) {
	    this.asSpecializedKind = asSpecializedKind;
	}
	
	
	
	/**
	 * Add a asSpecializedKind to the asSpecializedKind collection.
	 * @param asSpecializedKind_elt Element to add.
	 */
	public void addAsSpecializedKind(net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind asSpecializedKind_elt) {
	    this.asSpecializedKind.add(asSpecializedKind_elt);
	}
	
	/**
	 * Remove a asSpecializedKind to the asSpecializedKind collection.
	 * @param asSpecializedKind_elt Element to remove
	 */
	public void removeAsSpecializedKind(net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind asSpecializedKind_elt) {
	    this.asSpecializedKind.remove(asSpecializedKind_elt);
	}
	
	/**
	 * Return part.
	 * @return part
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVPart> getPart() {
		if (part == null) {
	        part = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVPart>();
	    }
	    return part;
	}
	
	/**
	 * Set a value to attribute part.
	 * @param part.
	 */
	public void setPart(List<net.ihe.gazelle.medication.COCTMT230100UVPart> part) {
	    this.part = part;
	}
	
	
	
	/**
	 * Add a part to the part collection.
	 * @param part_elt Element to add.
	 */
	public void addPart(net.ihe.gazelle.medication.COCTMT230100UVPart part_elt) {
	    this.part.add(part_elt);
	}
	
	/**
	 * Remove a part to the part collection.
	 * @param part_elt Element to remove
	 */
	public void removePart(net.ihe.gazelle.medication.COCTMT230100UVPart part_elt) {
	    this.part.remove(part_elt);
	}
	
	/**
	 * Return ingredient.
	 * @return ingredient
	 */
	public List<net.ihe.gazelle.medication.COCTMT230100UVIngredient> getIngredient() {
		if (ingredient == null) {
	        ingredient = new ArrayList<net.ihe.gazelle.medication.COCTMT230100UVIngredient>();
	    }
	    return ingredient;
	}
	
	/**
	 * Set a value to attribute ingredient.
	 * @param ingredient.
	 */
	public void setIngredient(List<net.ihe.gazelle.medication.COCTMT230100UVIngredient> ingredient) {
	    this.ingredient = ingredient;
	}
	
	
	
	/**
	 * Add a ingredient to the ingredient collection.
	 * @param ingredient_elt Element to add.
	 */
	public void addIngredient(net.ihe.gazelle.medication.COCTMT230100UVIngredient ingredient_elt) {
	    this.ingredient.add(ingredient_elt);
	}
	
	/**
	 * Remove a ingredient to the ingredient collection.
	 * @param ingredient_elt Element to remove
	 */
	public void removeIngredient(net.ihe.gazelle.medication.COCTMT230100UVIngredient ingredient_elt) {
	    this.ingredient.remove(ingredient_elt);
	}
	
	/**
	 * Return classCode.
	 * @return classCode
	 */
	public net.ihe.gazelle.voc.EntityClassManufacturedMaterial getClassCode() {
	    return classCode;
	}
	
	/**
	 * Set a value to attribute classCode.
	 * @param classCode.
	 */
	public void setClassCode(net.ihe.gazelle.voc.EntityClassManufacturedMaterial classCode) {
	    this.classCode = classCode;
	}
	
	
	
	
	/**
	 * Return determinerCode.
	 * @return determinerCode
	 */
	public net.ihe.gazelle.voc.EntityDeterminerDetermined getDeterminerCode() {
	    return determinerCode;
	}
	
	/**
	 * Set a value to attribute determinerCode.
	 * @param determinerCode.
	 */
	public void setDeterminerCode(net.ihe.gazelle.voc.EntityDeterminerDetermined determinerCode) {
	    this.determinerCode = determinerCode;
	}
	
	
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor
	 */
	public net.ihe.gazelle.voc.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor.
	 */
	public void setNullFlavor(net.ihe.gazelle.voc.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.cdaepsos");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "POCD_MT000040.Material").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(POCDMT000040Material pOCDMT000040Material, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (pOCDMT000040Material != null){
   			cvm.validate(pOCDMT000040Material, location, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.CS realmCode: pOCDMT000040Material.getRealmCode()){
					net.ihe.gazelle.datatypes.CS.validateByModule(realmCode, location + "/realmCode[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.cda.POCDMT000040InfrastructureRootTypeId.validateByModule(pOCDMT000040Material.getTypeId(), location + "/typeId", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.datatypes.II templateId: pOCDMT000040Material.getTemplateId()){
					net.ihe.gazelle.datatypes.II.validateByModule(templateId, location + "/templateId[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.II.validateByModule(pOCDMT000040Material.getId(), location + "/id", cvm, diagnostic);
			net.ihe.gazelle.datatypes.CE.validateByModule(pOCDMT000040Material.getCode(), location + "/code", cvm, diagnostic);
			net.ihe.gazelle.datatypes.EN.validateByModule(pOCDMT000040Material.getName(), location + "/name", cvm, diagnostic);
			net.ihe.gazelle.medication.ED.validateByModule(pOCDMT000040Material.getDesc(), location + "/desc", cvm, diagnostic);
			net.ihe.gazelle.medication.CE.validateByModule(pOCDMT000040Material.getRiskCode(), location + "/riskCode", cvm, diagnostic);
			net.ihe.gazelle.medication.CE.validateByModule(pOCDMT000040Material.getHandlingCode(), location + "/handlingCode", cvm, diagnostic);
			net.ihe.gazelle.medication.CE.validateByModule(pOCDMT000040Material.getFormCode(), location + "/formCode", cvm, diagnostic);
			net.ihe.gazelle.datatypes.ST.validateByModule(pOCDMT000040Material.getLotNumberText(), location + "/lotNumberText", cvm, diagnostic);
			net.ihe.gazelle.medication.IVLTS.validateByModule(pOCDMT000040Material.getExpirationTime(), location + "/expirationTime", cvm, diagnostic);
			net.ihe.gazelle.medication.IVLTS.validateByModule(pOCDMT000040Material.getStabilityTime(), location + "/stabilityTime", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct asDistributedProduct: pOCDMT000040Material.getAsDistributedProduct()){
					net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct.validateByModule(asDistributedProduct, location + "/asDistributedProduct[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer asMedicineManufacturer: pOCDMT000040Material.getAsMedicineManufacturer()){
					net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer.validateByModule(asMedicineManufacturer, location + "/asMedicineManufacturer[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			net.ihe.gazelle.medication.COCTMT230100UVContent.validateByModule(pOCDMT000040Material.getAsContent(), location + "/asContent", cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind asSpecializedKind: pOCDMT000040Material.getAsSpecializedKind()){
					net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind.validateByModule(asSpecializedKind, location + "/asSpecializedKind[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVPart part: pOCDMT000040Material.getPart()){
					net.ihe.gazelle.medication.COCTMT230100UVPart.validateByModule(part, location + "/part[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
			{
				int i = 0;
				for (net.ihe.gazelle.medication.COCTMT230100UVIngredient ingredient: pOCDMT000040Material.getIngredient()){
					net.ihe.gazelle.medication.COCTMT230100UVIngredient.validateByModule(ingredient, location + "/ingredient[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}